library IEEE;
use IEEE.std_logic_1164.all;

entity statmach is
port(     CLK: in STD_LOGIC;
        RESET: in STD_LOGIC;
     STRTSTOP: in STD_LOGIC;
        CLKEN: out STD_LOGIC;
          RST: out STD_LOGIC);
end statmach;

architecture inside of statmach is

type stmchine_state is (clear,zero,start,counting,stop,stopped);
signal current_state : stmchine_state;
   signal next_state : stmchine_state;

begin

process(STRTSTOP,current_state)
    begin
	case current_state is
	    when clear=>
	   next_state<=zero;
		CLKEN<='0';
                  RST<='1';
	    when zero=>
		if(STRTSTOP='0') then
		    next_state<=zero;
		elsif(STRTSTOP='1') then
		    next_state<=start;
		end if;
		CLKEN<='0';
                  RST<='0';		
	    when start=>
		if(STRTSTOP='0') then
		    next_state<=counting;
		elsif(STRTSTOP='1') then
		    next_state<=start;
		end if;
		CLKEN<='0';
                  RST<='0';		
	    when counting=>
		if(STRTSTOP='0') then
		    next_state<=counting;
		elsif(STRTSTOP='1') then
		    next_state<=stop;
		end if;
		CLKEN<='1';
                  RST<='0';		
	    when stop=>
		if(STRTSTOP='0') then
		    next_state<=stopped;
		elsif(STRTSTOP='1') then
		    next_state<=stop;
		end if;
		CLKEN<='0';
                  RST<='0';		
	    when stopped=>
		if(STRTSTOP='0') then
		    next_state<=stopped;
		elsif(STRTSTOP='1') then
		    next_state<=start;
		end if;
		CLKEN<='0';
                  RST<='0';		
	end case;
    end process;

process(RESET,CLK)
    begin
	if(RESET='1') then
	    current_state<=clear;
	elsif(CLK'event and CLK='1') then
	    current_state<=next_state;
	end if;
    end process;

end inside;
